diff --git a/src/Contap/Contap_Contour.cxx b/src/Contap/Contap_Contour.cxx
index d23c73f..89a181d 100644
--- a/src/Contap/Contap_Contour.cxx
+++ b/src/Contap/Contap_Contour.cxx
@@ -280,13 +280,12 @@ static void Recadre(const Handle(Adaptor3d_HSurface)& myHS1,
 
 
 static void LineConstructor(Contap_TheSequenceOfLine& slin,
-                            const Handle(Adaptor3d_TopolTool)& Domain,
+                            const Handle(Adaptor3d_TopolTool)& theDomain,
                             Contap_Line& L,
                             const Handle(Adaptor3d_HSurface)& Surf) { 
 
                               //-- ------------------------------------------------------------
                               //-- on decoupe la ligne en portions  entre 2 vertex 
-                              Standard_Real Tol = Precision::PConfusion();
                               Contap_IType typl = L.TypeContour();
                               //-- cout<<"\n ----------- Ligne Constructor "<<endl;
                               if(typl == Contap_Walking) { 
@@ -301,7 +300,8 @@ static void LineConstructor(Contap_TheSequenceOfLine& slin,
                                     const IntSurf_PntOn2S& Pmid = L.Point(pmid);
                                     Pmid.Parameters(u1,v1,u2,v2);
                                     Recadre(Surf,u2,v2);
-                                    TopAbs_State in2 = Domain->Classify(gp_Pnt2d(u2,v2),Tol);
+                                    TopAbs_State in2 = theDomain->Classify(gp_Pnt2d(u2, v2),
+                                                                           Precision::Confusion());
                                     if(in2 == TopAbs_OUT) { 
                                     }
                                     else { 
@@ -352,7 +352,8 @@ static void LineConstructor(Contap_TheSequenceOfLine& slin,
                                     }
 
                                     Recadre(Surf,u2,v2);
-                                    TopAbs_State in2 = Domain->Classify(gp_Pnt2d(u2,v2),Tol);
+                                    TopAbs_State in2 = theDomain->Classify(gp_Pnt2d(u2, v2),
+                                                                           Precision::Confusion());
                                     if(in2 == TopAbs_OUT) { 
                                     }
                                     else { 
@@ -399,7 +400,8 @@ static void LineConstructor(Contap_TheSequenceOfLine& slin,
                                     }
 
                                     Recadre(Surf,u2,v2);
-                                    TopAbs_State in2 = Domain->Classify(gp_Pnt2d(u2,v2),Tol);
+                                    TopAbs_State in2 = theDomain->Classify(gp_Pnt2d(u2, v2),
+                                                                           Precision::Confusion());
                                     if(in2 == TopAbs_OUT) { 
                                     }
                                     else { 
@@ -438,7 +440,8 @@ static void LineConstructor(Contap_TheSequenceOfLine& slin,
                                     }
 
                                     Recadre(Surf,u2,v2);
-                                    TopAbs_State in2 = Domain->Classify(gp_Pnt2d(u2,v2),Tol);
+                                    TopAbs_State in2 = theDomain->Classify(gp_Pnt2d(u2, v2),
+                                                                           Precision::Confusion());
                                     if(in2 == TopAbs_OUT) { 
                                     }
                                     else { 
@@ -505,7 +508,7 @@ static void KeepInsidePoints(const Contap_TheSearchInside& solins,
 
 
 static void ComputeTangency (const Contap_TheSearch& solrst,
-                             const Handle(Adaptor3d_TopolTool)& Domain,
+                             const Handle(Adaptor3d_TopolTool)& theDomain,
                              Contap_SurfFunction& Func,
                              IntSurf_SequenceOfPathPoint& seqpdep,
                              TColStd_Array1OfInteger& Destination)
@@ -561,7 +564,7 @@ static void ComputeTangency (const Contap_TheSearch& solrst,
           }
       }
       if(SurUneRestrictionSolution == Standard_False) { 
-        arcorien = Domain->Orientation(thearc);
+        arcorien = theDomain->Orientation(thearc);
         ispassing = (arcorien == TopAbs_INTERNAL ||
           arcorien == TopAbs_EXTERNAL);
 
@@ -581,10 +584,10 @@ static void ComputeTangency (const Contap_TheSearch& solrst,
                 const Contap_ThePathPointOfTheSearch& PStart2 = solrst.Point(k);
                 if (!PStart2.IsNew()) {
                   const Handle(Adaptor3d_HVertex)& vtx2 = PStart2.Vertex();
-                  if (Domain->Identical(vtx,vtx2)) {
+                  if (theDomain->Identical(vtx,vtx2)) {
                     const Handle(Adaptor2d_HCurve2d)& thearc2   = PStart2.Arc();
                     theparam = PStart2.Parameter();
-                    arcorien = Domain->Orientation(thearc2);
+                    arcorien = theDomain->Orientation(thearc2);
                     ispassing = ispassing && (arcorien == TopAbs_INTERNAL ||
                       arcorien == TopAbs_EXTERNAL);
 
@@ -648,7 +651,7 @@ static void ComputeTangency (const Contap_TheSearch& solrst,
                 arcorien != TopAbs_EXTERNAL) {
                   // pour essai
                   const Handle(Adaptor3d_HVertex)& vtx = PStart.Vertex();
-                  vtxorien = Domain->Orientation(vtx);
+                  vtxorien = theDomain->Orientation(vtx);
                   test = test/(vectg.Magnitude());
                   test = test/((normale.Crossed(tg3drst)).Magnitude());
 
@@ -675,10 +678,10 @@ static void ComputeTangency (const Contap_TheSearch& solrst,
                   const Contap_ThePathPointOfTheSearch& PStart2 = solrst.Point(k);
                   if (!PStart2.IsNew()) {
                     const Handle(Adaptor3d_HVertex)& vtx2 = PStart2.Vertex();
-                    if (Domain->Identical(PStart.Vertex(),vtx2)) {
+                    if (theDomain->Identical(PStart.Vertex(),vtx2)) {
                       const Handle(Adaptor2d_HCurve2d)& thearc2 = PStart2.Arc();
                       theparam = PStart2.Parameter();
-                      arcorien = Domain->Orientation(thearc2);
+                      arcorien = theDomain->Orientation(thearc2);
 
                       Contap_HCurve2dTool::D1(thearc2,theparam,pt2d,tg2drst);
                       X(1) = pt2d.X();
@@ -693,7 +696,7 @@ static void ComputeTangency (const Contap_TheSearch& solrst,
                           test = test/(vectg.Magnitude());
                           test = test /((normale.Crossed(tg3drst)).Magnitude());
 
-                          vtxorien = Domain->Orientation(vtx2);
+                          vtxorien = theDomain->Orientation(vtx2);
                           if (Abs(test) <= tole) {
                             tobeverified = Standard_True;
                             LocTrans = TopAbs_EXTERNAL; // et pourquoi pas INTERNAL
@@ -746,13 +749,13 @@ static void ComputeTangency (const Contap_TheSearch& solrst,
                   if (Destination(k)==seqlength + 1) {
                     theparam = solrst.Point(k).Parameter();
                     const Handle(Adaptor2d_HCurve2d)& thearc2 = solrst.Point(k).Arc();
-                    arcorien = Domain->Orientation(thearc2);
+                    arcorien = theDomain->Orientation(thearc2);
 
                     if (arcorien == TopAbs_FORWARD ||
                       arcorien == TopAbs_REVERSED) {
                         Contap_HCurve2dTool::D1(thearc2,theparam,pt2d,tg2drst);
                         tg3drst = tg2drst.X()*v1 + tg2drst.Y()*v2;
-                        vtxorien = Domain->Orientation(solrst.Point(k).Vertex());
+                        vtxorien = theDomain->Orientation(solrst.Point(k).Vertex());
                         if ((arcorien == TopAbs_FORWARD && 
                           vtxorien == TopAbs_REVERSED)    ||
                           (arcorien == TopAbs_REVERSED &&
@@ -858,7 +861,7 @@ void ProcessSegments (const Contap_TheSearch& solrst,
                       Contap_TheSequenceOfLine& slin,
                       const Standard_Real TolArc,
                       Contap_SurfFunction& SFunc,
-                      const Handle(Adaptor3d_TopolTool)& Domain)
+                      const Handle(Adaptor3d_TopolTool)& theDomain)
 
 {     
   Standard_Integer i,j,k;
@@ -992,7 +995,7 @@ void ProcessSegments (const Contap_TheSearch& solrst,
     if (thesegsol.HasFirstPoint() && thesegsol.HasLastPoint()) {
       ComputeInternalPointsOnRstr(theline,paramf,paraml,SFunc);
     }
-    LineConstructor(slin,Domain,theline,SFunc.Surface()); //-- lbr 
+    LineConstructor(slin,theDomain,theline,SFunc.Surface()); //-- lbr 
     //-- slin.Append(theline);
     theline.Clear();
   }
@@ -1364,8 +1367,8 @@ void ComputeInternalPoints
 }
 
 
-void Contap_Contour::Perform 
-(const Handle(Adaptor3d_TopolTool)& Domain) {
+void Contap_Contour::Perform(const Handle(Adaptor3d_TopolTool)& theDomain)
+{
 
   done = Standard_False;
   slin.Clear();
@@ -1444,7 +1447,7 @@ void Contap_Contour::Perform
   mySFunc.Set(Precision::Confusion()); // tolerance sur la fonction
 
   Standard_Boolean RecheckOnRegularity = Standard_True;
-  solrst.Perform(myAFunc,Domain,TolArc,TolArc,RecheckOnRegularity);
+  solrst.Perform(myAFunc,theDomain,TolArc,TolArc,RecheckOnRegularity);
 
   if (!solrst.IsDone()) {
     return;
@@ -1455,11 +1458,11 @@ void Contap_Contour::Perform
   TColStd_Array1OfInteger Destination(1,NbPointRst+1);
   Destination.Init(0);
   if (NbPointRst != 0) {
-    ComputeTangency(solrst,Domain,mySFunc,seqpdep,Destination);
+    ComputeTangency(solrst,theDomain,mySFunc,seqpdep,Destination);
   }
 
   //jag 940616  solins.Perform(SFunc,Surf,Domain,1.e-6); // 1.e-6 : tolerance dans l espace.
-  solins.Perform(mySFunc,Surf,Domain,Precision::Confusion());
+  solins.Perform(mySFunc,Surf,theDomain,Precision::Confusion());
 
   NbPointIns = solins.NbPoints();
   IntSurf_SequenceOfInteriorPoint seqpins;
@@ -1618,7 +1621,7 @@ void Contap_Contour::Perform
       }
 
       ComputeInternalPoints(theline,mySFunc,EpsU,EpsV);
-      LineConstructor(slin,Domain,theline,Surf); //-- lbr
+      LineConstructor(slin,theDomain,theline,Surf); //-- lbr
       //-- slin.Append(theline);
       theline.ResetSeqOfVertex();
     }
@@ -1654,7 +1657,7 @@ void Contap_Contour::Perform
   // jag 940620 On ajoute le traitement des restrictions solutions.
 
   if (solrst.NbSegments() !=0) {
-    ProcessSegments(solrst,slin,TolArc,mySFunc,Domain);
+    ProcessSegments(solrst,slin,TolArc,mySFunc,theDomain);
   }
 
 
@@ -1918,7 +1921,7 @@ IntSurf_TypeTrans ComputeTransitionOngpCircle
 }
 
 
-void Contap_Contour::PerformAna(const Handle(Adaptor3d_TopolTool)& Domain)
+void Contap_Contour::PerformAna(const Handle(Adaptor3d_TopolTool)& theDomain)
 {
 
   done = Standard_False;
@@ -2114,7 +2117,7 @@ void Contap_Contour::PerformAna(const Handle(Adaptor3d_TopolTool)& Domain)
 
   if(PerformSolRst) { 
 
-    solrst.Perform(myAFunc,Domain,TolArc,TolArc);
+    solrst.Perform(myAFunc,theDomain,TolArc,TolArc);
     if (!solrst.IsDone()) {
       return;
     }
@@ -2125,7 +2128,7 @@ void Contap_Contour::PerformAna(const Handle(Adaptor3d_TopolTool)& Domain)
     }
 
     if (solrst.NbSegments() !=0) {
-      ProcessSegments(solrst,slin,TolArc,mySFunc,Domain);
+      ProcessSegments(solrst,slin,TolArc,mySFunc,theDomain);
     }
 
 
@@ -2139,7 +2142,7 @@ void Contap_Contour::PerformAna(const Handle(Adaptor3d_TopolTool)& Domain)
       //-- cout<<" nbvtx : "<<slin.Value(i).NbVertex()<<endl;
       //--if(slin.Value(i).NbVertex() > 1) { 
       if(slin.Value(i).TypeContour() != Contap_Restriction) { 
-        LineConstructor(slin,Domain,slin.ChangeValue(i),Surf);
+        LineConstructor(slin,theDomain,slin.ChangeValue(i),Surf);
         SeqToDestroy.Append(i);
       }
       //-- }
diff --git a/src/DsgPrs/DsgPrs_ShapeDirPresentation.cxx b/src/DsgPrs/DsgPrs_ShapeDirPresentation.cxx
index b86ed2c..007a5d6 100644
--- a/src/DsgPrs/DsgPrs_ShapeDirPresentation.cxx
+++ b/src/DsgPrs/DsgPrs_ShapeDirPresentation.cxx
@@ -18,7 +18,6 @@
 #include <Bnd_Box.hxx>
 #include <BRep_Tool.hxx>
 #include <BRepBndLib.hxx>
-#include <BRepClass_Edge.hxx>
 #include <BRepClass_FaceClassifier.hxx>
 #include <BRepTools_WireExplorer.hxx>
 #include <DsgPrs_ShapeDirPresentation.hxx>
diff --git a/src/Geom2dHatch/Geom2dHatch_Classifier.hxx b/src/Geom2dHatch/Geom2dHatch_Classifier.hxx
index 025c184..876cdaa 100644
--- a/src/Geom2dHatch/Geom2dHatch_Classifier.hxx
+++ b/src/Geom2dHatch/Geom2dHatch_Classifier.hxx
@@ -19,113 +19,46 @@
 
 #include <Standard.hxx>
 #include <Standard_DefineAlloc.hxx>
-#include <Standard_Handle.hxx>
 
-#include <Geom2dHatch_FClass2dOfClassifier.hxx>
-#include <Geom2dAdaptor_Curve.hxx>
-#include <Standard_Real.hxx>
 #include <IntRes2d_Position.hxx>
-#include <Standard_Boolean.hxx>
 #include <TopAbs_State.hxx>
-class Standard_DomainError;
+#include <TopClass_GeomEdge.hxx>
+
 class Geom2dHatch_Elements;
-class Geom2dAdaptor_Curve;
-class Geom2dHatch_Intersector;
-class Geom2dHatch_FClass2dOfClassifier;
 class gp_Pnt2d;
 
-
-
 class Geom2dHatch_Classifier 
 {
 public:
 
   DEFINE_STANDARD_ALLOC
 
-  
+
   //! Empty constructor, undefined algorithm.
   Standard_EXPORT Geom2dHatch_Classifier();
-  
-  //! Creates an algorithm to classify the Point  P with
-  //! Tolerance <T> on the face described by <F>.
-  Standard_EXPORT Geom2dHatch_Classifier(Geom2dHatch_Elements& F, const gp_Pnt2d& P, const Standard_Real Tol);
-  
-  //! Classify  the Point  P  with  Tolerance <T> on the
-  //! face described by <F>.
-  Standard_EXPORT void Perform (Geom2dHatch_Elements& F, const gp_Pnt2d& P, const Standard_Real Tol);
-  
-  //! Returns the result of the classification.
-  Standard_EXPORT TopAbs_State State() const;
-  
-  //! Returns  True when  the   state was computed by  a
-  //! rejection. The state is OUT.
-    Standard_Boolean Rejected() const;
-  
-  //! Returns True if  the face  contains  no wire.  The
-  //! state is IN.
-    Standard_Boolean NoWires() const;
-  
-  //! Returns   the    Edge  used   to    determine  the
-  //! classification. When the State is ON  this  is the
-  //! Edge containing the point.
-  Standard_EXPORT const Geom2dAdaptor_Curve& Edge() const;
-  
-  //! Returns the parameter on Edge() used to determine  the
-  //! classification.
-  Standard_EXPORT Standard_Real EdgeParameter() const;
-  
-  //! Returns the  position of  the   point on the  edge
-  //! returned by Edge.
-    IntRes2d_Position Position() const;
-
 
+  //! Classify the Point P with 2D-tolerance <theTol2D> relatively to
+  //! the contour set by the 2D-curves in <F>.
+  Standard_EXPORT void Perform(Geom2dHatch_Elements& F,
+                               const gp_Pnt2d& P,
+                               const Standard_Real theTol2D);
 
+  //! Returns the result of the classification.
+  Standard_EXPORT TopAbs_State State() const;
 
 protected:
 
 
-
-  Geom2dHatch_FClass2dOfClassifier myClassifier;
-  Geom2dAdaptor_Curve myEdge;
-  Standard_Real myEdgeParameter;
-  IntRes2d_Position myPosition;
-  Standard_Boolean rejected;
-  Standard_Boolean nowires;
-
-
 private:
 
+  //! ATTENTION!!!
+  //! Fields myEdge and myEdgeParameter
+  //! should be eliminated after removing TopOpeBRep*
+  //! packages.
 
-
-
-
+  TopClass_GeomEdge myEdge;
+  Standard_Real myEdgeParameter;
+  TopAbs_State myState;
 };
 
-#define TheFaceExplorer Geom2dHatch_Elements
-#define TheFaceExplorer_hxx <Geom2dHatch_Elements.hxx>
-#define TheEdge Geom2dAdaptor_Curve
-#define TheEdge_hxx <Geom2dAdaptor_Curve.hxx>
-#define TheIntersection2d Geom2dHatch_Intersector
-#define TheIntersection2d_hxx <Geom2dHatch_Intersector.hxx>
-#define TopClass_FClass2d Geom2dHatch_FClass2dOfClassifier
-#define TopClass_FClass2d_hxx <Geom2dHatch_FClass2dOfClassifier.hxx>
-#define TopClass_FaceClassifier Geom2dHatch_Classifier
-#define TopClass_FaceClassifier_hxx <Geom2dHatch_Classifier.hxx>
-
-#include <TopClass_FaceClassifier.lxx>
-
-#undef TheFaceExplorer
-#undef TheFaceExplorer_hxx
-#undef TheEdge
-#undef TheEdge_hxx
-#undef TheIntersection2d
-#undef TheIntersection2d_hxx
-#undef TopClass_FClass2d
-#undef TopClass_FClass2d_hxx
-#undef TopClass_FaceClassifier
-#undef TopClass_FaceClassifier_hxx
-
-
-
-
 #endif // _Geom2dHatch_Classifier_HeaderFile
diff --git a/src/Geom2dHatch/Geom2dHatch_Classifier_0.cxx b/src/Geom2dHatch/Geom2dHatch_Classifier_0.cxx
index 431f1d8..8811a39 100644
--- a/src/Geom2dHatch/Geom2dHatch_Classifier_0.cxx
+++ b/src/Geom2dHatch/Geom2dHatch_Classifier_0.cxx
@@ -26,8 +26,12 @@
 
 #define TheFaceExplorer Geom2dHatch_Elements
 #define TheFaceExplorer_hxx <Geom2dHatch_Elements.hxx>
-#define TheEdge Geom2dAdaptor_Curve
-#define TheEdge_hxx <Geom2dAdaptor_Curve.hxx>
+
+//! Are used only for compatibility with TopOpeBRep
+//! packages. It should be deleted after this package will be eliminated.
+#define TheTopoEdge Geom2dAdaptor_Curve
+#define TheTopoEdge_hxx <Geom2dAdaptor_Curve.hxx>
+
 #define TheIntersection2d Geom2dHatch_Intersector
 #define TheIntersection2d_hxx <Geom2dHatch_Intersector.hxx>
 #define TopClass_FClass2d Geom2dHatch_FClass2dOfClassifier
diff --git a/src/Geom2dHatch/Geom2dHatch_Elements.cxx b/src/Geom2dHatch/Geom2dHatch_Elements.cxx
index d487ee7..41a42dd 100644
--- a/src/Geom2dHatch/Geom2dHatch_Elements.cxx
+++ b/src/Geom2dHatch/Geom2dHatch_Elements.cxx
@@ -1,4 +1,4 @@
-// Created on: 1994-12-16
+﻿// Created on: 1994-12-16
 // Created by: Laurent BUCHARD
 // Copyright (c) 1994-1999 Matra Datavision
 // Copyright (c) 1999-2014 OPEN CASCADE SAS
@@ -16,31 +16,22 @@
 
 //  Modified by skv - Fri Jul 14 17:03:47 2006 OCC12627
 
-#include <Geom2dAdaptor_Curve.hxx>
-#include <Geom2dHatch_Element.hxx>
 #include <Geom2dHatch_Elements.hxx>
-#include <gp.hxx>
-#include <gp_Lin2d.hxx>
-#include <gp_Pnt2d.hxx>
-#include <gp_Vec2d.hxx>
-#include <Standard_DomainError.hxx>
-#include <Standard_Integer.hxx>
-#include <Standard_NoSuchObject.hxx>
-#include <TColStd_MapIntegerHasher.hxx>
-#include <TopAbs_Orientation.hxx>
-
-Geom2dHatch_Elements::Geom2dHatch_Elements(const Geom2dHatch_Elements& )
+
+#include <TopClass_GeomEdge.hxx>
+#include <TopClass_RayInfo.hxx>
+
+Geom2dHatch_Elements::
+  Geom2dHatch_Elements(const Geom2dHatch_Elements&) :myCurrentWire(0),
+                                                     myCurEdge(0)
 {
 #ifdef OCCT_DEBUG
   cout<<" Magic Constructor in Geom2dHatch_Elements:: "<<endl;
 #endif
 }
 
-Geom2dHatch_Elements::Geom2dHatch_Elements()
+Geom2dHatch_Elements::Geom2dHatch_Elements() :myCurrentWire(0)
 {
-  NumWire = 0;
-  NumEdge = 0;
-  myCurEdge = 1;
 }
 
 void Geom2dHatch_Elements::Clear()
@@ -84,65 +75,51 @@ Standard_Boolean  Geom2dHatch_Elements::CheckPoint(gp_Pnt2d&)
 }
 
 //=======================================================================
-//function : Reject
-//purpose  : 
-//=======================================================================
-
-Standard_Boolean  Geom2dHatch_Elements::Reject(const gp_Pnt2d&) const  {
-  return Standard_False;
-}
-
-//=======================================================================
-//function : Segment
-//purpose  : 
+//function : OtherRay
+//purpose  : theMaxRating is kept for compatibility with analogical
+//            method in BRepClass_FaceExplorer.
 //=======================================================================
-
-Standard_Boolean Geom2dHatch_Elements::Segment(const gp_Pnt2d& P, 
-					             gp_Lin2d& L, 
-					             Standard_Real& Par)
+Standard_Boolean Geom2dHatch_Elements::OtherRay(const gp_Pnt2d& thePnt,
+                                                TopClass_RayInfo& theRay,
+                                                const unsigned int /*theMaxRating*/)
 {
-  myCurEdge = 1;
-
-  return OtherSegment(P, L, Par);
-}
-
-//=======================================================================
-//function : Segment
-//purpose  : 
-//=======================================================================
-
-Standard_Boolean Geom2dHatch_Elements::OtherSegment(const gp_Pnt2d& P, 
-						          gp_Lin2d& L, 
-						          Standard_Real& Par)
-{
-  Geom2dHatch_DataMapIteratorOfMapOfElements Itertemp;
-  Standard_Integer                        i;
-  
-  for(  Itertemp.Initialize(myMap), i = 1; Itertemp.More(); Itertemp.Next(), i++) { 
+  Geom2dHatch_DataMapIteratorOfMapOfElements Itertemp(myMap);
+  Standard_Integer i = 1;
+  for (; Itertemp.More(); Itertemp.Next(), i++)
+  {
     if (i < myCurEdge)
       continue;
 
-    void *ptrmyMap = (void *)(&myMap);
-    Geom2dHatch_Element& Item=((Geom2dHatch_MapOfElements*)ptrmyMap)->ChangeFind(Itertemp.Key());
-    Geom2dAdaptor_Curve& E = Item.ChangeCurve();
-    TopAbs_Orientation Or= Item.Orientation();
-    gp_Pnt2d P2 = E.Value
-      ((E.FirstParameter() + E.LastParameter()) *0.5);
-    if ((Or == TopAbs_FORWARD) ||
-	(Or == TopAbs_REVERSED)) {
-      gp_Vec2d V(P,P2);
-      Par = V.Magnitude();
-      if (Par >= gp::Resolution()) {
-	L = gp_Lin2d(P,V);
-	myCurEdge++;
-	return Standard_True;
-      }
+    const Standard_Integer anIdx = Itertemp.Key();
+    const Geom2dHatch_Element& anItem = myMap.Find(anIdx);
+    const Geom2dAdaptor_Curve& E = anItem.Curve();
+    const TopAbs_Orientation anOri = anItem.Orientation();
+    if ((anOri != TopAbs_FORWARD) && (anOri != TopAbs_REVERSED))
+    {
+      myCurEdge++;
+      continue;
+    }
+
+    TopClass_RayInfo aRI;
+    const gp_Pnt2d aPE = E.Value((E.FirstParameter() + E.LastParameter()) *0.5);
+    const gp_Vec2d aV(thePnt, aPE);
+    aRI.SetParameter(aV.Magnitude());
+    if (aRI.GetParameter() < gp::Resolution())
+    {
+      myCurEdge++;
+      continue;
     }
+
+    aRI.SetLin(gp_Lin2d(thePnt, aV));
+    theRay = aRI;
+    myCurEdge++;
+    return Standard_True;
   }
 
-  if (i == myCurEdge + 1) {
-    Par = RealLast();
-    L = gp_Lin2d(P,gp_Dir2d(1,0));
+  if (i == myCurEdge + 1)
+  {
+    theRay.SetParameter(RealLast());
+    theRay.SetLin(gp_Lin2d(thePnt, gp_Dir2d(1, 0)));
     myCurEdge++;
 
     return Standard_True;
@@ -156,19 +133,9 @@ Standard_Boolean Geom2dHatch_Elements::OtherSegment(const gp_Pnt2d& P,
 //purpose  : 
 //=======================================================================
 
-void  Geom2dHatch_Elements::InitWires()  {
-  NumWire = 0;
-}
-
-//=======================================================================
-//function : RejectWire NYI
-//purpose  : 
-//=======================================================================
-
-Standard_Boolean Geom2dHatch_Elements::RejectWire(const gp_Lin2d& , 
-						   const Standard_Real) const 
+void  Geom2dHatch_Elements::InitWires()
 {
-  return Standard_False;
+  myCurrentWire = 0;
 }
 
 //=======================================================================
@@ -176,41 +143,20 @@ Standard_Boolean Geom2dHatch_Elements::RejectWire(const gp_Lin2d& ,
 //purpose  : 
 //=======================================================================
 
-void  Geom2dHatch_Elements::InitEdges()  {
-  NumEdge = 0;
-  Iter.Initialize(myMap);
-}
-
-//=======================================================================
-//function : RejectEdge NYI
-//purpose  : 
-//=======================================================================
-
-Standard_Boolean Geom2dHatch_Elements::RejectEdge(const gp_Lin2d& , 
-						  const Standard_Real ) const 
+void  Geom2dHatch_Elements::InitEdges()
 {
-  return Standard_False;
+  myIter.Initialize(myMap);
 }
 
-
 //=======================================================================
 //function : CurrentEdge
 //purpose  : 
 //=======================================================================
 
-void  Geom2dHatch_Elements::CurrentEdge(Geom2dAdaptor_Curve& E, 
-					TopAbs_Orientation& Or) const 
+void  Geom2dHatch_Elements::CurrentEdge(TopClass_GeomEdge& theGE) const 
 {
-  void *ptrmyMap = (void *)(&myMap);
-  Geom2dHatch_Element& Item=((Geom2dHatch_MapOfElements*)ptrmyMap)->ChangeFind(Iter.Key());
-
-  E = Item.ChangeCurve();
-  Or= Item.Orientation();
-#if 0 
-  E.Edge() = TopoDS::Edge(myEExplorer.Current());
-  E.Face() = myFace;
-  Or = E.Edge().Orientation();
-#endif
+  const Geom2dHatch_Element& anItem = myMap.Find(myIter.Key());
+  theGE.Replace2DCurve(anItem.Curve(), anItem.Orientation());
 }
 
 
@@ -221,7 +167,7 @@ void  Geom2dHatch_Elements::CurrentEdge(Geom2dAdaptor_Curve& E,
 
 Standard_Boolean  Geom2dHatch_Elements::MoreWires() const 
 {
-  return (NumWire == 0);
+  return (myCurrentWire == 0);
 }
 
 //=======================================================================
@@ -229,8 +175,9 @@ Standard_Boolean  Geom2dHatch_Elements::MoreWires() const
 //purpose  : 
 //=======================================================================
 
-void Geom2dHatch_Elements::NextWire()  {
-  NumWire++;
+void Geom2dHatch_Elements::NextWire()
+{
+  myCurrentWire++;
 }
 
 //=======================================================================
@@ -238,8 +185,9 @@ void Geom2dHatch_Elements::NextWire()  {
 //purpose  : 
 //=======================================================================
 
-Standard_Boolean  Geom2dHatch_Elements::MoreEdges() const  {
-  return(Iter.More());
+Standard_Boolean  Geom2dHatch_Elements::MoreEdges() const
+{
+  return(myIter.More());
 }
 
 //=======================================================================
@@ -247,9 +195,44 @@ Standard_Boolean  Geom2dHatch_Elements::MoreEdges() const  {
 //purpose  : 
 //=======================================================================
 
-void Geom2dHatch_Elements::NextEdge()  {
-  Iter.Next();
+void Geom2dHatch_Elements::NextEdge()
+{
+  myIter.Next();
 }
 
+//=======================================================================
+//function : IsPointInEdgeVertex
+//purpose  : 
+//=======================================================================
+Standard_Boolean
+  Geom2dHatch_Elements::IsPointInEdgeVertex(const gp_Pnt2d &thePnt,
+                                            Standard_Real* const theParameter) const
+{
+  const Geom2dAdaptor_Curve& aCurv = myMap.Find(myIter.Key()).Curve();
+  const gp_Pnt2d aPntF(aCurv.Value(aCurv.FirstParameter())),
+                 aPntL(aCurv.Value(aCurv.LastParameter()));
+  const Standard_Real aSqTol = Precision::SquarePConfusion();
+
+  if (thePnt.SquareDistance(aPntF) < aSqTol)
+  {
+    if (theParameter)
+      *theParameter = aCurv.FirstParameter();
+
+    return Standard_True;
+  }
+
+  if (thePnt.SquareDistance(aPntL) < aSqTol)
+  {
+    if (theParameter)
+      *theParameter = aCurv.LastParameter();
+
+    return Standard_True;
+  }
+
+  if (theParameter)
+    *theParameter = 0.0;
+
+  return Standard_False;
+}
 
 
diff --git a/src/Geom2dHatch/Geom2dHatch_Elements.hxx b/src/Geom2dHatch/Geom2dHatch_Elements.hxx
index 5ef0623..7b0b9d0 100644
--- a/src/Geom2dHatch/Geom2dHatch_Elements.hxx
+++ b/src/Geom2dHatch/Geom2dHatch_Elements.hxx
@@ -17,24 +17,11 @@
 #ifndef _Geom2dHatch_Elements_HeaderFile
 #define _Geom2dHatch_Elements_HeaderFile
 
-#include <Standard.hxx>
-#include <Standard_DefineAlloc.hxx>
-#include <Standard_Handle.hxx>
-
 #include <Geom2dHatch_MapOfElements.hxx>
-#include <Geom2dHatch_DataMapIteratorOfMapOfElements.hxx>
-#include <Standard_Integer.hxx>
-#include <Standard_Boolean.hxx>
-#include <Standard_Real.hxx>
-#include <TopAbs_Orientation.hxx>
-class Standard_DomainError;
-class Standard_NoSuchObject;
-class Geom2dHatch_Element;
-class gp_Pnt2d;
-class gp_Lin2d;
-class Geom2dAdaptor_Curve;
-
+#include <NCollection_List.hxx>
 
+class TopClass_GeomEdge;
+class TopClass_RayInfo;
 
 class Geom2dHatch_Elements 
 {
@@ -48,80 +35,84 @@ public:
   Standard_EXPORT Geom2dHatch_Elements(const Geom2dHatch_Elements& Other);
   
   Standard_EXPORT void Clear();
-~Geom2dHatch_Elements()
-{
-  Clear();
-}
+  ~Geom2dHatch_Elements()
+  {
+    Clear();
+  }
   
-  Standard_EXPORT Standard_Boolean Bind (const Standard_Integer K, const Geom2dHatch_Element& I);
+  Standard_EXPORT Standard_Boolean Bind (const Standard_Integer K,
+                                         const Geom2dHatch_Element& I);
   
   Standard_EXPORT Standard_Boolean IsBound (const Standard_Integer K) const;
   
   Standard_EXPORT Standard_Boolean UnBind (const Standard_Integer K);
   
-  Standard_EXPORT const Geom2dHatch_Element& Find (const Standard_Integer K) const;
-const Geom2dHatch_Element& operator() (const Standard_Integer K) const
-{
-  return Find(K);
-}
+  Standard_EXPORT const Geom2dHatch_Element& Find(const Standard_Integer K) const;
+  const Geom2dHatch_Element& operator() (const Standard_Integer K) const
+  {
+    return Find(K);
+  }
   
-  Standard_EXPORT Geom2dHatch_Element& ChangeFind (const Standard_Integer K);
-Geom2dHatch_Element& operator() (const Standard_Integer K)
-{
-  return ChangeFind(K);
-}
+  Standard_EXPORT Geom2dHatch_Element& ChangeFind(const Standard_Integer K);
+  Geom2dHatch_Element& operator() (const Standard_Integer K)
+  {
+    return ChangeFind(K);
+  }
+
+  //! This function is entered only for compatibility with BRepClass*.
   Standard_EXPORT Standard_Boolean CheckPoint (gp_Pnt2d& P);
 
-  Standard_EXPORT Standard_Boolean Reject (const gp_Pnt2d& P) const;
-  
-  Standard_EXPORT Standard_Boolean Segment (const gp_Pnt2d& P, gp_Lin2d& L, Standard_Real& Par);
-  
-  Standard_EXPORT Standard_Boolean OtherSegment (const gp_Pnt2d& P, gp_Lin2d& L, Standard_Real& Par);
-  
+  //! Returns ray to process.
+  //! theMaxRating variable is entered for compatibility with
+  //! BRepClass* classes and is not use here.
+  Standard_EXPORT Standard_Boolean OtherRay(const gp_Pnt2d& thePnt,
+                                            TopClass_RayInfo& theRay,
+                                            const unsigned int theMaxRating);
+
   Standard_EXPORT void InitWires();
   
   Standard_EXPORT Standard_Boolean MoreWires() const;
   
   Standard_EXPORT void NextWire();
   
-  Standard_EXPORT Standard_Boolean RejectWire (const gp_Lin2d& L, const Standard_Real Par) const;
-  
   Standard_EXPORT void InitEdges();
   
   Standard_EXPORT Standard_Boolean MoreEdges() const;
   
   Standard_EXPORT void NextEdge();
   
-  Standard_EXPORT Standard_Boolean RejectEdge (const gp_Lin2d& L, const Standard_Real Par) const;
-  
-  Standard_EXPORT void CurrentEdge (Geom2dAdaptor_Curve& E, TopAbs_Orientation& Or) const;
-
-
+  //! Returns analyzed edge.
+  Standard_EXPORT void CurrentEdge(TopClass_GeomEdge& theGE) const;
 
+  //! Returns TRUE if thePnt is covered by the tolerance of at least one
+  //! vertex of the analyzed edge.
+  //! If is true then stores the parameter of the vertex on the curve.
+  //! Otherwise, returns *theParameter = 0.0.
+  //! This parameter is used in TopOpeBRep class
+  //! and must be deleted after this class will be eliminated.
+  Standard_EXPORT 
+    Standard_Boolean IsPointInEdgeVertex(const gp_Pnt2d &thePnt,
+                                         Standard_Real* const theParameter = 0) const;
 
-protected:
+  Standard_Boolean FirstRay(const gp_Pnt2d& theP,
+                            TopClass_RayInfo& theRay,
+                            const unsigned int theMaxRating = UINT_MAX)
+  {
+    myCurEdge = 1;
 
+    return OtherRay(theP, theRay, theMaxRating);
+  }
 
 
 
+protected:
+  
 
 private:
-
-
-
   Geom2dHatch_MapOfElements myMap;
-  Geom2dHatch_DataMapIteratorOfMapOfElements Iter;
-  Standard_Integer NumWire;
-  Standard_Integer NumEdge;
+  Geom2dHatch_DataMapIteratorOfMapOfElements myIter;
+  Standard_Integer myCurrentWire;
   Standard_Integer myCurEdge;
-
-
 };
 
-
-
-
-
-
-
 #endif // _Geom2dHatch_Elements_HeaderFile
